From 46086a36a72c71456b47f17a3ea9a1f10f68c127 Mon Sep 17 00:00:00 2001
From: Haidong Yu <yuhaidong@uniontech.com>
Date: Mon, 7 Jun 2021 17:47:33 +0800
Subject: [PATCH] shell32: Fix a memory leak.

Signed-off-by: Haidong Yu <yuhaidong@uniontech.com>
---
 dlls/shell32/shelllink.c | 5 ++++-
 1 file changed, 4 insertions(+), 1 deletion(-)

diff --git a/dlls/shell32/shelllink.c b/dlls/shell32/shelllink.c
index 69d610f2503..2353ac3e56e 100644
--- a/dlls/shell32/shelllink.c
+++ b/dlls/shell32/shelllink.c
@@ -2158,7 +2158,10 @@ static HRESULT WINAPI IShellLinkW_fnSetPath(IShellLinkW * iface, LPCWSTR pszFile
         if (*pszFile == '\0')
             *buffer = '\0';
         else if (!GetFullPathNameW(pszFile, MAX_PATH, buffer, &fname))
-	    return E_FAIL;
+        {
+            heap_free(unquoted);
+            return E_FAIL;
+        }
         else if(!PathFileExistsW(buffer) &&
 		!SearchPathW(NULL, pszFile, NULL, MAX_PATH, buffer, NULL))
 	  hr = S_FALSE;
-- 
2.20.1

